#include <iostream>
using namespace std;

void tridiag(const int N, double sub[], double dia[], double sup[], double rhs[], double sol[])
{
  int k;
  double A[N], G[N];
  A[0] = 1. / dia[0];
  G[0] = sup[0]*A[0];
  for(k=1; k<=(N-2); k++)
    {
      A[k] = 1. / (dia[k] - sub[k]*G[k-1]);
      G[k] = sup[k]*A[k];
    }
  A[N-1] = 1. / (dia[N-1]-sub[N-1]*G[N-2]);

  sol[0] = rhs[0] * A[0];
  for(k=1; k<=(N-1); k++)
    {
      sol[k] = (rhs[k]-sub[k]*sol[k-1])*A[k];
    }
  for(k=N-2;k>=0; k--)
    {
      sol[k] = sol[k] - G[k]*sol[k+1];
    }
}
